#!/usr/bin/python
# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2008 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import openobject.xmlrpc as rpc
from time import sleep

def createfulldb(dbobj, dbname, withdemo=True, langcode='en_US', adminpassword='admin'):
    if dbname in dbobj.list():
        raise Exception('DB %s already exists' % (dbname,))

    try:
        dbid = dbobj.create(dbname, withdemo, langcode)#, adminpassword)
        while True:
            sleep(0.5)
            p, users = dbobj.get_progress(dbid)
            if p == 1.0:
                break

        cnx = rpc.Connection(server=dbobj.server, port=dbobj.port, dbname=dbname, login="admin", password=adminpassword)
        nottoinstall = ('base', 'l10n_fr', 'l10n_chart_uk_minimal', 'l10n_ch',)
        
        modules = rpc.Object(cnx, "ir.module.module")
        modids = modules.search([])#[('name', 'not in', repr(nottoinstall))])
    
        # Mark modules to be installed
        modules.button_install(modids)

        # Install modules (this take a while, really)
        wiz = rpc.Wizard(cnx, 'module.upgrade')
        wiz.init()
        wiz.start()
        
    except:
        if dbname in dbobj.list():
            dbobj.drop(dbname)
        raise


def main(dbname):
    db = rpc.Database()
    createfulldb(db, dbname)
    return 0

if __name__ == '__main__':
    import sys
    if len(sys.argv) != 2:
        print "Usage:"
        print "\t%s <dbname>" % (sys.argv[0],)
        exit(1)
        
    exit(main(sys.argv[1]))

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

